#include <Ecore_Evas.h>
#include <Ecore.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include <assassin.h>
#include <gears.h>
#include <debug.h>

#include <pkutil.h>
#include <confirm_command.h>
#include <dummy.h>

Ecore_Evas  *   ee;


Evas_Object * set_background(Evas *evas) {
	Evas_Object *   background;
	background = evas_object_rectangle_add(evas);
	evas_object_resize( background,  SCREEN_WIDTH, SCREEN_HEIGHT);
	evas_object_pass_events_set(background, 0);
	set_color(background, SCREEN_COLOR, 255);
	evas_object_show(background);
	return background;
}

static void usage(char *self) {
	printf("Usage: %s <install|update|uninstall> packageid\n", self);
	exit(0);
}

static struct Target * get_properties(int args, char ** argv) {
	enum ActionType at;
	struct  Target *T;
	if (args < 3) {
		usage(argv[0]);
	}
	if (!strcmp(argv[1], "install")) {
		at = INSTALL;
	} else if (!strcmp(argv[1], "update")) {
		at = UPDATE;
	} else if (!strcmp(argv[1], "uninstall")) {
		at = UNINSTALL;
	} else {
		usage(argv[0]);
	}
	T = (struct Target*) malloc(sizeof(struct Target));
	memset(T, 0, sizeof(*T));
	T->type = at;
	T->status = INITIAL;
	T->package = strdup(argv[2]);
	debug("Type: %d status: %d T->package is %s\n", T->type, T->status, T->package);
	return T;
}

static void free_target (struct Target * target) {
	if (!target) return;
	if (target->package)
		free(target->package);
	free(target);
}

int main (int args, char ** argv) {
	Evas_Object *   background;
	Evas        *   evas;
	//struct Target *target;

	//target = get_properties(args, argv);

	if (!ecore_init()) { error("failed to init ecore\n"); return -1; }
	if (!ecore_evas_init()) { error("failed to init ecore_evas\n"); return -1; }
	if (!edje_init()) { error("failed to init edje\n"); return -1; }
	if (!pk_e_dbus_init()) {error("failed to init pk_e_dbus\n");return -1;}

	ee = ecore_evas_software_x11_new(NULL, 0,  0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
	ecore_evas_borderless_set(ee, 1);
	ecore_evas_show(ee);
	evas = ecore_evas_get(ee);
	evas_font_path_append(evas, "fonts/");
	background = set_background(evas);


	//dummy_alert_new();
	pk_dummy_search_name("aspell");
	//pk_dummy_search_name("firefox");
	//dummy_progressbar_new();
	show_categories_ilist();
	new_buttom_bar(evas);
	//do_confirm(evas, target);
	
	ecore_main_loop_begin();
	//free_target(target);
}
