#include <browser.h>
#include <enlightenment/e_scrollframe.h>
#include <Ecore_Evas.h>
#include <debug.h>
#include <packagekit/pk-package-id.h>
#include <widgets/e_ilist.h>
#include <string.h>
#include <assassin.h>
#include <gears.h>

Evas_Object *browser_categories_ilist = NULL;

enum ActionType get_actiontype();
extern  Ecore_Evas  *   ee;
static void categories_selected(void *data,void *data2);

struct _categories {
	const char * title;
	PkGroupEnum group;
	void (*func1) (void *data, void *data2);
	void (*func2) (void *data, void *data2);
	void *data1;
	void *data2;
};
#define NUMBER_BUTTOM_LIST 3
struct Group_List {
	Evas_Object * list[NUMBER_BUTTOM_LIST];
};

struct _categories CATEGORIES[] = {
	{"Communication", 	PK_GROUP_ENUM_COMMUNICATION,	&categories_selected, NULL, NULL, NULL}, 
	{"Development",		PK_GROUP_ENUM_PROGRAMMING,	&categories_selected, NULL, NULL, NULL}, 
	{"Games", 		PK_GROUP_ENUM_GAMES,		&categories_selected, NULL, NULL, NULL}, 
	{"Maps", 		PK_GROUP_ENUM_MAPS,		&categories_selected, NULL, NULL, NULL}, 
	{"Miscellaneous", 	PK_GROUP_ENUM_UNKNOWN,		&categories_selected, NULL, NULL, NULL}, 
	{"Network", 		PK_GROUP_ENUM_NETWORK,		&categories_selected, NULL, NULL, NULL}, 
	{"Repos", 		PK_GROUP_ENUM_REPOS,		&categories_selected, NULL, NULL, NULL}, 
	{NULL, 			0,				NULL, NULL, NULL, NULL}  // The last one is full of NULL pointers
};




Evas_Object * get_current_list(Evas_Object *obj) {
	static Evas_Object * __current_list=NULL;
	Evas_Object *o;
	if (obj==NULL) {
		if (__current_list==NULL) {
			debug("Warning: __current_list is NULL\n");
		}
		debug("__current_list is %p\n",__current_list);
		return __current_list;
	}
	if (obj != __current_list) {
		o=__current_list;
		__current_list = obj;
		evas_object_show(obj);
		debug("Set current list to %p\n",__current_list);
		return o;
	}
	evas_object_show(obj);
	debug("__current_list is %p\n",__current_list);
	return obj;
}

#define MOVING_SPPED_MAGIC  0.5f
static int __moving_left_list(void *data) ;
static int __moving_right_list(void *data) ;
static Ecore_Animator * __moving_progress__=NULL;
double __starting_timer__;

void moving_right_list (void *data) {
	int x,y,w,h;
	Evas_Object *slist = (Evas_Object *) data;

	if (__moving_progress__) {
		error("This shall not happened!!\n");
		return;
	}
	if (slist==NULL) {
		slist = get_current_list(NULL);
		debug("slist is NULL! use get_current_list %p\n",slist);
	}
	debug("slist %p\n",slist);
	evas_object_geometry_get(browser_categories_ilist,&x,&y,&w,&h);
	if (get_current_list(NULL) == browser_categories_ilist) {
		debug("categories list is already there!!\n");
		return;
	}

	evas_object_move(browser_categories_ilist,-WIDTH(),0);
	evas_object_show(browser_categories_ilist);

	__moving_progress__=ecore_animator_add(__moving_right_list,slist);
	__starting_timer__=ecore_time_get();
}

static void moving_left_list (void *data) {
	Evas_Object *slist = (Evas_Object *) data;
	Evas_Coord mw, mh;

	if (__moving_progress__) {
		error("This shall not happened!!\n");
		return;
	}
	e_ilist_min_size_get (slist,&mw,&mh);
	evas_object_resize(slist,WIDTH(),mh);
	evas_object_move(slist,WIDTH(),0);
	evas_object_show(slist);
	__moving_progress__=ecore_animator_add(__moving_left_list, slist);
	__starting_timer__=ecore_time_get();
}

static int __moving_right_list(void *data)  {
	Evas_Object *slist=(Evas_Object *) data;
	const double finished_time=MOVING_SPPED_MAGIC;
	double elapse_time = ecore_time_get() - __starting_timer__;
	double pos;
	if (!slist) {
		debug("Warning!! Slist is NULL!!\n");
	}
	pos = elapse_time / finished_time;
	pos = pos*pos*pos;
	pos = pos >= 1 ? 1.0 : pos;
	pos *= WIDTH();

	if (slist) {
		evas_object_move(slist,pos,0);
	}
	evas_object_move(browser_categories_ilist,pos-WIDTH(),0);

	if (elapse_time < finished_time) {
		return 1;
	}
	if (slist) {
		evas_object_hide(slist);
	}
	
	ecore_animator_del(__moving_progress__);
	__moving_progress__=NULL;
	get_current_list(browser_categories_ilist);
	return 0;
}


static int __moving_left_list(void *data)  {
	Evas_Object *slist = (Evas_Object *) data;
	const double finished_time=MOVING_SPPED_MAGIC;
 	double elapse_time = (ecore_time_get()  - __starting_timer__)/1.0f;
	double pos;

	if (slist==NULL) {
		error("slist is NULL!!\n");
		return 0;
	}

	pos = elapse_time / finished_time;
	pos = pos*pos*pos;
	pos = pos >=1 ?  1 : pos;
	pos = WIDTH() * pos;

	pos = pos < 0 ? 0 : pos;
	evas_object_move(slist,WIDTH() - pos,0);
	pos = 0 - pos;
	evas_object_move(browser_categories_ilist,pos,0);

	if (elapse_time < finished_time) {
		return 1;
	}

	evas_object_hide(browser_categories_ilist);
	ecore_animator_del(__moving_progress__);
	__moving_progress__=NULL;
	get_current_list(slist);
	return 0;
}

static int __show_the_package_view(void *data) {
	Evas_Object *slist = (Evas_Object *) data;
	const double finished_time=MOVING_SPPED_MAGIC;
 	double elapse_time = (ecore_time_get() - __starting_timer__)/1.0f;
	double pos;

	if (slist==NULL) {
		error("slist is NULL!!\n");
		return 0;
	}
	pos = elapse_time / finished_time;
	pos = pos*pos*pos;
	pos = pos >=1 ?  1 : pos;
	pos = WIDTH() * pos;

	pos = pos < 0 ? 0 : pos;
	evas_object_move(slist,WIDTH() - pos,0);
	pos = 0 - pos;
	evas_object_move(get_current_list(NULL),pos,0);

	if (elapse_time < finished_time) {
		return 1;
	}

	evas_object_hide(get_current_list(NULL));
	ecore_animator_del(__moving_progress__);
	__moving_progress__=NULL;
	get_current_list(slist);
	return 0;

}
static void show_the_package_view(Evas_Object *package_view) {
	struct Buttom_Bottons * B = new_buttom_bar(ecore_evas_get(ee));
	int x,y,h,w;
	if (__moving_progress__) {
		error("The last animator is not finished!!\n");
		return;
	}
	evas_object_geometry_get(B->buttons,&x,&y,&w,&h);
	evas_object_resize(package_view,WIDTH(),HEIGHT()-h);
	evas_object_move(package_view,WIDTH(),0);
	evas_object_show(package_view);
	__moving_progress__ = ecore_animator_add(__show_the_package_view, package_view);
	__starting_timer__=ecore_time_get();
}

void confirm_action_cb(void *data, Evas_Object *obj, const char *emission, const char *source)  {
	char * pid = (char *)data;
	struct Target * target = (struct Target*) malloc(sizeof(struct Target));
	memset(target, 0, sizeof(sizeof(struct Target)));
	target->status = INITIAL;
	target->package = strdup(pid);
	target->type = get_buttom_bar_selected_type();
	do_confirm(ecore_evas_get(ee),target);
}

// prepare for the package view
static void pk_get_description_cb (void *data, DBusMessage *message) {
	Pk_Operation * pko = (Pk_Operation *)data;
	Evas_Object * package_view;
	DBusError _err;
	char buf[MAX_PACKAGE_NAME_SIZE];
	char name[MAX_PACKAGE_NAME_SIZE];
	int ret;
	char *tid;
	char *packageid;
	char *license;
	char *group_text;
	char *description;
	char *url;
	unsigned int size;
	if (!data) {
		error("data shall not be null!!\n");
		return;
	}
	dbus_error_init(&_err);	
	ret=dbus_message_get_args(message,&_err,
			DBUS_TYPE_STRING, &tid,
			DBUS_TYPE_STRING, &packageid, 
			DBUS_TYPE_STRING, &license, 
			DBUS_TYPE_STRING, &group_text, 
			DBUS_TYPE_STRING, &description, 
			DBUS_TYPE_STRING, &url, 
			DBUS_TYPE_UINT64, &size, 
			DBUS_TYPE_INVALID);
	package_view = (Evas_Object *) pko->payload;
	if (ret==0) {
		error("Error message: %s\n",_err.message);
		dbus_error_free(&_err);
		return;
	}
	dbus_error_free(&_err);
	if (!pk_should_proxy(pko,tid)) {
		return;
	}
	get_pk_name_from_id(packageid,name,sizeof(name));
	debug("get %s description!!\n",name);
	sprintf(buf,"Categories / %s / %s",group_text,name);
	edje_object_part_text_set(package_view,"section.info.text",buf);
	edje_object_part_text_set(package_view,"package.description.text",description);
	sprintf(buf,"Download size: %d KB",(int)size);
	edje_object_part_text_set(package_view,"package.size.text",buf);


	show_the_package_view(package_view);
}

static void package_selected(void *data,void *data2) {
	Pk_Operation *pko;
	char *packageid=(char *)data;
	if (packageid==NULL) {
		error("packageid is NULL!!\n");
		return;
	}
	pko = (Pk_Operation *) malloc (sizeof(Pk_Operation));
	memset(pko, 0 , sizeof(Pk_Operation));

	pko->Operations[Description_sig] = & pk_get_description_cb;
	pko->payload = (void *)new_package_view(ecore_evas_get(ee),packageid); 

	edje_object_signal_callback_add(pko->payload, "mouse,clicked,1","thumbnail", &confirm_action_cb, packageid);
	pk_get_description (pko,packageid);
}

static void categories_selected(void *data,void *data2) {
	if (!data) {
		error("data is NULL\n");
		return;
	}
	moving_left_list(((struct Group_List *)data)->list[get_buttom_bar_selected_type()]);
}

Evas_Object * get_categories_ilist() {
	Evas        *   evas = ecore_evas_get(ee);
	const int IT_HEADER=1;
	int i;
	if (!browser_categories_ilist) {
		browser_categories_ilist = (Evas_Object *)e_ilist_add(evas);
		evas_object_hide(browser_categories_ilist);
		e_ilist_append(browser_categories_ilist, NULL, "Categories", IT_HEADER, NULL, NULL, NULL, NULL);

		for (i = 0;CATEGORIES[i].title != NULL;i++) {
			CATEGORIES[i].data1 = get_packages_ilist ( CATEGORIES[i].title, CATEGORIES[i].group, CATEGORIES[i].data1);
			e_ilist_append(browser_categories_ilist, NULL ,CATEGORIES[i].title, !IT_HEADER,
					CATEGORIES[i].func1, CATEGORIES[i].func2, 
					CATEGORIES[i].data1, CATEGORIES[i].data2);
		}
	}
	return browser_categories_ilist;
}
inline int get_GL_index(char *info) {
	const char * AVAILIABLE="available";
	const char * INSTALLED ="installed";
	const int INDEX_INSTALL=0;
	const int INDEX_UPDATE=1;
	const int INDEX_UNINSTALL=2;


	if (!info) return -1;
	if (!strncmp(info,AVAILIABLE,strlen(AVAILIABLE))) {
		return INDEX_INSTALL;
	}else if (!strncmp(info,INSTALLED,strlen(INSTALLED))) {
		return INDEX_UNINSTALL;
	}else if (!strncmp(info,"low",strlen("low")) ||
			!strncmp(info,"enhancement",strlen("enhancement"))) {
		return INDEX_UNINSTALL;
	}
	return -1;
}

#define LENGTH_NAME_SHOWED 13
static void pk_default_search_group_cb (void *data, DBusMessage *message) {
	const int ITISHEADER=1;
	DBusError _err;
	char * tid;
	char * info;
	char * packageid;
	char * summary;
	int ret;
	Pk_Operation * pko = (Pk_Operation *)data;
	struct Group_List * GL = (struct Group_List *)pko-> payload;
	char name[LENGTH_NAME_SHOWED];
	int x,y,lw,lh;


	//debug("Gnget Package!!\n");
	dbus_error_init(&_err);
	ret=dbus_message_get_args(message,&_err,
			DBUS_TYPE_STRING, &tid,
			DBUS_TYPE_STRING, &info,
			DBUS_TYPE_STRING, &packageid,
			DBUS_TYPE_STRING, &summary,
			DBUS_TYPE_INVALID);
	if (!ret) {
		error("error message: '%s'\n",_err.message);
		dbus_error_free(&_err);
		return;
	}
	dbus_error_free(&_err);
	if (!pk_should_proxy(pko,tid)) {
		return;
	}
	if (GL==NULL) {
		error("GL shall not be Null now!!\n");
		return;
	}
	ret = get_GL_index(info);
	if (ret < 0) {
		debug("info of package: '%s' is '%s' and assassin do not know that!\n",packageid,info);
		return;
	}
	get_pk_name_from_id(packageid,name,sizeof(name));
	packageid = strdup(packageid);
	e_ilist_append(GL->list[ret] , NULL, (char *)name, !ITISHEADER, 
			&package_selected, NULL, 
			packageid, NULL);
	evas_object_geometry_get(GL->list[ret],&x,&y,&lw,&lh);
	evas_object_resize(GL->list[ret],WIDTH(),lh);
	if (GL->list[ret]==get_current_list(NULL)) {
		evas_object_move(GL->list[ret],0,0);
	}else {
		evas_object_hide(GL->list[ret]);
	}
	debug("Putting %s into %d\n",name, ret);
}


static void search_group(PkGroupEnum group, struct Group_List *GL) {
	Pk_Operation *  pko = (Pk_Operation *) malloc(sizeof(Pk_Operation));
	memset(pko,0,sizeof(Pk_Operation));
	debug("Search group %d %s\n",group, pk_group_enum_to_text(group));
	pko->Operations[Package_sig]=&pk_default_search_group_cb;
	pko->payload = GL;
	pk_search_group(pko,pk_group_enum_to_text(group));
}


struct Group_List * get_packages_ilist(const char *header, PkGroupEnum group, void *data) {
	Evas        *   evas = ecore_evas_get(ee);
	struct Group_List * GL=(struct Group_List *) data;
	char buf[MAX_PACKAGE_NAME_SIZE];
	int i;
	if (data==NULL) {
		GL= (struct Group_List * )malloc(sizeof(struct Group_List));
		sprintf(buf,"Categories / %s",header);
		for (i=0; i<NUMBER_BUTTOM_LIST; i++) {
			GL->list[i] =  (Evas_Object *)e_ilist_add(evas);
			evas_object_hide(GL->list[i]);   // Default is hide
			e_ilist_append(GL->list[i], NULL, buf, 1, NULL, NULL, NULL, NULL);
		}
		search_group(group,GL);
	}
	return GL;
}

void show_categories_ilist () {
	Evas_Coord mw, mh;
	Evas_Object * list = get_categories_ilist();
	e_ilist_min_size_get (list,&mw,&mh);
	evas_object_resize(list,WIDTH(),mh);
	evas_object_move(list,0,0);
	get_current_list(list);
}
