#include <pk-package-id.h>
#include <confirm_command.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
#include <assassin.h>
#include <gears.h>
#include <actions.h>

extern Ecore_Evas * ee;

static void assassin_confirm_positive (void *data,  Evas_Object *obj, const char *emission, const char *source) {
	struct Installer_Progressbar * AP;
	debug("Yes selected!!\n");
	struct Target *target = (struct Target *)((struct Installer_Alert *) data)->data;
	free_Alert((struct Installer_Alert*)data);
	debug("target->package=%s\n", target->package);
	action(target);
}
static void assassin_confirm_negative (void *data,  Evas_Object *obj, const char *emission, const char *source) {
	debug("No selected!!\n");
	exit(0);
}



struct Installer_Alert *  do_confirm(Evas *evas, struct Target * target) {
	char name[MAX_PACKAGE_NAME_SIZE];
	char *type;
	struct Installer_Alert *AA;
	CallbackFunc pos, neg;
	neg = &assassin_confirm_negative;
	pos = &assassin_confirm_positive;
	if (!get_pk_name_from_id(target->package, name, sizeof(name))) {
		error("Cannot get package name from ID\n");
		return NULL;
	}
	if (target->type == INSTALL) {
		type = "INSTALL";
	} else if (target->type == UPDATE) {
		type = "UPDATE";
	} else if (target->type == UNINSTALL) {
		type = "UNINSTALL";
	} else {
		error("Invalid target type\n");
		return NULL;
	}
	debug("target->package=%s \n", target->package);
	AA = new_Alert(evas, type, name, "Yes", "No", target);
	if (!AA) {
		error("Create new Alert Failed!!!!\n");
		exit(1);
	}
	alert_set_callback(AA, pos, neg);
	target->status = WAITCONFIRM;
	return AA;
}
