#ifndef __ASSASSIN_GEARS__
#define __ASSASSIN_GEARS__

#include <Ecore.h>
#include <Ecore_Evas.h>
#include <Edje.h>

typedef void (* CallbackFunc) (void *data,  Evas_Object *obj, const char *emission, const char *source);

struct Installer_Alert {
	Evas_Object * alert;
	CallbackFunc  positive;
	CallbackFunc  negative;
	void * data;
};

void set_color(Evas_Object *o, int color, int alpha);

struct Installer_Alert * new_Alert (Evas *evas, const char *type, const char *message, const char *icon_p, const char *icon_n, void *data);
int alert_set_callback(struct Installer_Alert *, CallbackFunc pos, CallbackFunc neg);
void free_Alert(struct Installer_Alert *AA);

struct Installer_Progressbar {
	Evas_Object *bar;
	int progress;
	char *text;
	int MAX;
	int WIDTH;
};

struct Installer_Progressbar * new_Progressbar(Evas *evas, const char *text);
unsigned int progressbar_update(struct Installer_Progressbar *, unsigned int p);
unsigned int progressbar_text_set(struct Installer_Progressbar *, const char *text);
unsigned int progressbar_increase(struct Installer_Progressbar *, int v);
void free_Progressbar(struct Installer_Progressbar *);

struct Buttom_Bottons {
	Evas_Object *buttons;
	int selected;
};

struct Buttom_Bottons * new_buttom_bar(Evas *evas);
int get_buttom_bar_selected_type();

Evas_Object * new_package_view (Evas *evas, char *packageid);

struct Object_Shift {
	Evas_Object *obj;
	double finish_time;
	double start_time;
	int s_x;
	int s_y;
	int e_x;
	int e_y;
};

int WIDTH();
int HEIGHT();
void animator_move_object(Evas_Object *o,double time,int sx,int sy,int ex,int ey);

#endif
